<?PHP

/*

   This program simulates the results of a
   randomized rolling of up to six dice.

   This version is for PHP v7.0+ and makes
   use of the new Random_Int() function.

   AUTHOR   : Jay Tanner
   LANGUAGE : PHP 7.1.8

   License  : Public Domain

*/

   $ProgramVersion = "v3.0"; // Revised: 2021-Feb-24-Wed

// Get local year value from system clock.
   $year = date('Y');

// Get name of this program script.
   $_ACTION_FILE_NAME_ = Filter_Input(INPUT_SERVER, 'SCRIPT_NAME');

// Select random background color for dice display.
   $w = Random_Int(0, 255);   $R = ($w < 16)? '0'.DecHex($w) : DecHex($w);
   $w = Random_Int(0, 255);   $G = ($w < 16)? '0'.DecHex($w) : DecHex($w);
   $w = Random_Int(0, 255);   $B = ($w < 16)? '0'.DecHex($w) : DecHex($w);
   $RandBG = StrToUpper("#$R$G$B");

// Get selected number of dice to throw.
   $rButtonIndex = @Filter_Input(INPUT_POST, 'RButton');

// Initialize to roll two dice at startup.
   if ($rButtonIndex == '') {$rButtonIndex = 1;}

// Create radio button states array for 6 options.
   for ($i=0;   $i < 6;   $i++)
       {
        $rButton[$i] = ($i == $rButtonIndex)? 'checked' : '';
       }

// Number of dice to throw: 1|2|3|4|5|6
   $NumOfDice = $rButtonIndex + 1;

// Generate dice throws as HTML string.
   $DiceRollResult = '';
   $DiceSum = 0;

   for ($i=0;  $i < $NumOfDice;   $i++)
       {
        $R = Random_Int(1, 6); // Roll current die.

//      If die face value is 2, 3 or 6, then there
//      is an alternate version of the die face.
//      In the cases of those values, it becomes a
//      50/50 random decision if the alternate image
//      will be displayed.
        if ($R == 2 or $R == 3 or $R == 6)
           {
            if (Random_Int(1, 1000000000000) % 2 == 0) {$R .= 'a';}
           }

        $DiceSum += IntVal($R);
        $DiceRollResult .= "&nbsp;&nbsp;<img src='images/die-$R.png' ALT=''>&nbsp;&nbsp;";

       } // End of for()

print <<< _HTML
<!DOCTYPE HTML>

<HTML>

<head>

<title>Random Dice Roller</title>
<meta name='viewport' content='width=device-width, initial-scale=1'>
<meta http-equiv='content-type' content='text/html; charset=UTF-8'>
<meta name='description' content='This PHP program randomly rolls up to 6 dice.'>
<meta name='keywords' content='dice,random dice,dice roll,roll dice,PHPScienceLabs.com'>
<meta name='author' content='Jay Tanner - PHPScienceLabs.com'>
<meta http-equiv='pragma'  content='no-cache'>
<meta http-equiv='expires' content='-1'>
<meta name='robots'    content='index,follow'>
<meta name='googlebot' content='index,follow'>
<link rel="canonical" href="https://www.phpsciencelabs.com/random-dice-roller/">

<style type='text/css'>

BODY {color:white; background-color:black;  font-family:Verdana; font-size:14px}

TABLE {font-family:Verdana; font-size:14px;}

TD {color:black; background-color:white;  line-height:120%; font-size:125%; padding:6px; text-align:center;}


CODE {font-family:monospace; font-size:16px; font-weight:bold;}

TEXTAREA {color:black; background-color:white; font-family:monospace; font-size:18px; font-weight:bold; box-shadow:4px 4px 3px #999999; border-radius: 8px; border:1px solid black; padding:4px; white-space:pre;}

IMG {border:1px solid black; border-radius:8px; box-shadow:6px 6px 6px #333333;}

INPUT[type='text']::-ms-clear {width:0; height:0;}
INPUT[type='text']{color:black; background-color:white; font-family:monospace; font-size:18px; font-weight:bold; text-align:center; box-shadow:2px 2px 3px #999999; border:2px solid black;}
INPUT[type='text']:focus {color:black; background-color:white; font-family:monospace; font-size:18px; font-weight:bold; text-align:center; box-shadow:2px 2px 3px #666666; border:2px solid red;}

INPUT[type='submit']{font-size:120%; font-weight:normal; border:1px solid black; border-radius:8px;}
INPUT[type='submit']:hover {background:cyan; box-shadow:2px 2px 5px #222222; font-weight:normal;}

INPUT[type='checkbox']:checked {box-shadow:2px 2px 3px #222222;}

INPUT[type='radio']:checked {box-shadow:2px 2px 3px #222222;}

HR {background-color:black; height:2px; border:0px;}


::selection      {background-color:yellow; color:black;}  /* IE9+ and Safari     */
::-moz-selection {background-color:yellow; color:black;}  /* FireFox and Mozilla */

</style>


</head>

<body>

<form name='form1' action="$_ACTION_FILE_NAME_" method='post'>

<table width='790' cellpadding='4' align='left'>

<tr><td style='background:#000066; color:white; border:2px solid white; border-radius:8px 8px 0px 0px;'><H3 style='font-weight:normal;'>Random Dice Roller For Up To Six Dice</H3><span style='font-size:80%;'>PHP Program by Jay Tanner</span>
</td></tr>

<!-- Select number of dice to roll. -->
<tr><td style='background-color:LightCyan;' colspan='2'>
Dice to Roll: &nbsp; &nbsp;<b>1</b>
<input name='RButton' type='radio' value='0' $rButton[0]>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <b>2</b>
<input name='RButton' type='radio' value='1' $rButton[1]>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <b>3</b>
<input name='RButton' type='radio' value='2' $rButton[2]>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <b>4</b>
<input name='RButton' type='radio' value='3' $rButton[3]>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <b>5</b>
<input name='RButton' type='radio' value='4' $rButton[4]>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <b>6</b>
<input name='RButton' type='radio' value='5' $rButton[5]>
</td></tr>

<tr><td colspan='2' style="background:$RandBG;">$DiceRollResult</td></tr>

<tr><td colspan='2' style="font-size:125%; color:black; background-color:LightYellow;" >Rolled Total: <b>$DiceSum</b></td></tr>

<tr>
<td colspan='2' bgcolor='gray' align='center' style='border-radius:0px 0px 8px 8px;'>
<input name='Compute_Button' type='submit' value=' Roll '>
</td>
</tr>

<tr><td colspan='2' style='color:silver; background-color:black;'>&nbsp;</td></tr>

</table>

</form>

<hr size='4'>

</body>

</HTML>

_HTML;

// 6^6 = 46656

?>


